Your search did not match any results.

JavaScript/jQuery Diagram - UI Customization

The following properties allow you to customize the JavaScript Diagram component's UI elements:

Backend API
$(() => { const diagram = $('#diagram').dxDiagram({ contextMenu: { enabled: true, commands: ['bringToFront', 'sendToBack', 'lock', 'unlock'], }, contextToolbox: { enabled: true, category: 'flowchart', shapeIconsPerRow: 5, width: 200, }, propertiesPanel: { visibility: 'visible', tabs: [ { groups: [{ title: 'Page Properties', commands: ['pageSize', 'pageOrientation', 'pageColor'] }], }, ], }, historyToolbar: { visible: false, }, viewToolbar: { visible: true, }, mainToolbar: { visible: true, commands: [ { name: 'undo' }, { name: 'redo' }, { name: 'separator' }, { name: 'fontName' }, { name: 'fontSize' }, { name: 'separator' }, { name: 'bold' }, { name: 'italic' }, { name: 'underline' }, { name: 'separator' }, { name: 'fontColor' }, { name: 'lineColor' }, { name: 'fillColor' }, { name: 'separator' }, { name: 'clear', icon: 'clearsquare', text: 'Clear Diagram' }, ], }, toolbox: { visibility: 'visible', groups: [ 'general', { category: 'flowchart', title: 'Flowchart', expanded: true }, ], showSearch: false, shapeIconsPerRow: 4, width: 220, }, onCustomCommand(e) { if (e.name === 'clear') { const result = DevExpress.ui.dialog.confirm('Are you sure you want to clear the diagram? This action cannot be undone.', 'Warning'); result.done( (dialogResult) => { if (dialogResult) { e.component.import(''); } }, ); } }, }).dxDiagram('instance'); $.ajax({ url: '../../../../data/diagram-flow.json', dataType: 'text', success(data) { diagram.import(data); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <script src="https://cdn3.devexpress.com/jslib/25.2.8/js/dx-diagram.min.js"></script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx-diagram.min.css" /> <link rel="stylesheet" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" /> <script src="js/dx.all.js?v=25.2.8"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="diagram"> </div> </div> </body> </html>
#diagram { height: 900px; }
{ "page": { "width": 8400, "height": 11910, "pageWidth": 8400, "pageHeight": 11910, "pageLandscape": false, "gridSize": 180, "snapToGrid": true }, "connectors": [{ "key": "116", "points": [{ "x": 2160, "y": 1800 }, { "x": 2160, "y": 2340 } ], "zIndex": 0, "beginItemKey": "107", "beginConnectionPointIndex": 2, "endItemKey": "108", "endConnectionPointIndex": 0 }, { "key": "117", "points": [{ "x": 2160, "y": 3420 }, { "x": 2160, "y": 3960 } ], "zIndex": 0, "beginItemKey": "108", "beginConnectionPointIndex": 2, "endItemKey": "118", "endConnectionPointIndex": 0 }, { "key": "122", "points": [{ "x": 3420, "y": 4680 }, { "x": 5760, "y": 4680 } ], "zIndex": 0, "texts": { "0.45": "No" }, "beginItemKey": "118", "beginConnectionPointIndex": 1, "endItemKey": "121", "endConnectionPointIndex": 3 }, { "key": "123", "points": [{ "x": 6840, "y": 4140 }, { "x": 3420, "y": 2880 } ], "zIndex": 0, "beginItemKey": "121", "beginConnectionPointIndex": 0, "endItemKey": "108", "endConnectionPointIndex": 1 }, { "key": "126", "points": [{ "x": 3780, "y": 9180 }, { "x": 2880, "y": 10440 } ], "zIndex": 0, "texts": { "0.78": "A popular scenario?" }, "beginItemKey": "120", "beginConnectionPointIndex": 3, "endItemKey": "125", "endConnectionPointIndex": 0 }, { "key": "130", "points": [{ "x": 5220, "y": 9180 }, { "x": 6120, "y": 10440 } ], "zIndex": 0, "texts": { "0.77": "Missing info in\nthe documentation?" }, "beginItemKey": "120", "beginConnectionPointIndex": 1, "endItemKey": "127", "endConnectionPointIndex": 0 }, { "key": "132", "points": [{ "x": 2160, "y": 5400 }, { "x": 2160, "y": 6120 } ], "zIndex": 0, "texts": { "0.47": "Yes" }, "beginItemKey": "118", "beginConnectionPointIndex": 2, "endItemKey": "131", "endConnectionPointIndex": 0 }, { "key": "124", "points": [{ "x": 2160, "y": 7200 }, { "x": 4500, "y": 8820 } ], "zIndex": 0, "beginItemKey": "131", "beginConnectionPointIndex": 2, "endItemKey": "120", "endConnectionPointIndex": 0 }, { "key": "134", "points": [{ "x": 3420, "y": 6660 }, { "x": 5760, "y": 6660 } ], "zIndex": 0, "texts": { "0.5": "Need developer\nassistance?" }, "beginItemKey": "131", "beginConnectionPointIndex": 1, "endItemKey": "133", "endConnectionPointIndex": 3 }, { "key": "135", "points": [{ "x": 6840, "y": 7200 }, { "x": 4500, "y": 8820 } ], "zIndex": 0, "beginItemKey": "133", "beginConnectionPointIndex": 2, "endItemKey": "120", "endConnectionPointIndex": 0 } ], "shapes": [ { "key": "107", "type": "terminator", "text": "A new ticket", "x": 1440, "y": 1080, "width": 1440, "height": 720, "zIndex": 0 }, { "key": "108", "type": "process", "text": "Analyze\nthe issue", "x": 900, "y": 2340, "width": 2520, "height": 1080, "zIndex": 0 }, { "key": "118", "type": "decision", "text": "Do we have all\ninformation to\nwork with?", "x": 900, "y": 3960, "width": 2520, "height": 1440, "zIndex": 0 }, { "key": "120", "type": "terminator", "text": "Answered", "x": 3780, "y": 8640, "width": 1440, "height": 720, "zIndex": 0 }, { "key": "121", "type": "process", "text": "Request additional\ninformation or clarify\nthe scenario", "x": 5760, "y": 4140, "width": 2160, "height": 1080, "zIndex": 0 }, { "key": "125", "type": "process", "text": "Prepare an example in\nCode Central", "x": 1620, "y": 10440, "width": 2520, "height": 1080, "zIndex": 0 }, { "key": "127", "type": "process", "text": "Update the\ndocumentation", "x": 4860, "y": 10440, "width": 2520, "height": 1080, "zIndex": 0 }, { "key": "131", "type": "process", "text": "Process the\nticket", "x": 900, "y": 6120, "width": 2520, "height": 1080, "zIndex": 0 }, { "key": "133", "type": "process", "text": "Work with the\nR&D team", "x": 5760, "y": 6120, "width": 2160, "height": 1080, "zIndex": 0 }, { "key": "136", "type": "text", "locked": true, "text": "Ticket Processing Flow", "x": 360, "y": 360, "width": 7740, "height": 360, "zIndex": 0, "styleText": { "font-size": "14pt", "font-weight": "bold" } } ] }

Backend API
<template>
<DxDiagram
id="diagram"
ref="diagram"
@custom-command="onCustomCommand"
>
<DxContextMenu
:enabled="true"
:commands="['bringToFront', 'sendToBack' , 'lock' , 'unlock' ]"
/>
<DxContextToolbox
:enabled="true"
:category="'flowchart'"
:shape-icons-per-row="5"
:width="200"
/>
<DxPropertiesPanel
:visibility="'visible'"
>
<DxTab>
<DxGroup
:title="'Page Properties'"
:commands="['pageSize', 'pageOrientation' , 'pageColor' ]"
/>
</DxTab>
</DxPropertiesPanel>
<DxHistoryToolbar
:visible="false"
/>
<DxViewToolbar
:visible="true"
/>
<DxMainToolbar
:visible="true"
>
<DxCommand
:name="'undo'"
/>
<DxCommand
:name="'redo'"
/>
<DxCommand
:name="'separator'"
/>
<DxCommand
:name="'fontName'"
/>
<DxCommand
:name="'fontSize'"
/>
<DxCommand
:name="'separator'"
/>
<DxCommand
:name="'bold'"
/>
<DxCommand
:name="'italic'"
/>
<DxCommand
:name="'underline'"
/>
<DxCommand
:name="'separator'"
/>
<DxCommand
:name="'fontColor'"
/>
<DxCommand
:name="'lineColor'"
/>
<DxCommand
:name="'fillColor'"
/>
<DxCommand
:name="'separator'"
/>
<DxCommand
:name="'clear'"
:icon="'clearsquare'"
:text="'Clear Diagram'"
/>
</DxMainToolbar>
<DxToolbox
:visibility="'visible'"
:show-search="false"
:shape-icons-per-row="4"
:width="220"
>
<DxGroup
:category="'general'"
:title="'General'"
/>
<DxGroup
:category="'flowchart'"
:title="'Flowchart'"
:expanded="true"
/>
</DxToolbox>
</DxDiagram>
</template>
<script setup lang="ts">
import { watch, ref } from 'vue';
import {
DxDiagram,
DxContextMenu,
DxContextToolbox,
DxPropertiesPanel,
DxGroup,
DxTab,
DxHistoryToolbar,
DxViewToolbar,
DxMainToolbar,
DxCommand,
DxToolbox,
type DxDiagramTypes,
} from 'devextreme-vue/diagram';
import { confirm } from 'devextreme/ui/dialog';
import 'whatwg-fetch';
const diagram = ref();
watch(diagram,
({ instance }) => {
fetch('../../../../data/diagram-flow.json')
.then((response) => response.json())
.then((json) => {
instance.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
});
function onCustomCommand(e: DxDiagramTypes.CustomCommandEvent) {
if (e.name === 'clear') {
const result = confirm('Are you sure you want to clear the diagram? This action cannot be undone.', 'Warning');
result.then(
(dialogResult) => {
if (dialogResult) {
e.component.import('');
}
},
);
}
}
</script>
<style scoped>
#diagram {
height: 900px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
},
map: {
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.6/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.24/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.64/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.1.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="https://maxcdn.bootstrapcdn.com/font-awesome/4.6.3/css/font-awesome.min.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.4.5/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
{
"page": {
"width": 8400,
"height": 11910,
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": false,
"gridSize": 180,
"snapToGrid": true
},
"connectors": [{
"key": "116",
"points": [{
"x": 2160,
"y": 1800
}, {
"x": 2160,
"y": 2340
}
],
"zIndex": 0,
"beginItemKey": "107",
"beginConnectionPointIndex": 2,
"endItemKey": "108",
"endConnectionPointIndex": 0
}, {
"key": "117",
"points": [{
"x": 2160,
"y": 3420
}, {
"x": 2160,
"y": 3960
}
],
"zIndex": 0,
"beginItemKey": "108",
"beginConnectionPointIndex": 2,
"endItemKey": "118",
"endConnectionPointIndex": 0
}, {
"key": "122",
"points": [{
"x": 3420,
"y": 4680
}, {
"x": 5760,
"y": 4680
}
],
"zIndex": 0,
"texts": {
"0.45": "No"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 1,
"endItemKey": "121",
"endConnectionPointIndex": 3
}, {
"key": "123",
"points": [{
"x": 6840,
"y": 4140
}, {
"x": 3420,
"y": 2880
}
],
"zIndex": 0,
"beginItemKey": "121",
"beginConnectionPointIndex": 0,
"endItemKey": "108",
"endConnectionPointIndex": 1
}, {
"key": "126",
"points": [{
"x": 3780,
"y": 9180
}, {
"x": 2880,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.78": "A popular scenario?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 3,
"endItemKey": "125",
"endConnectionPointIndex": 0
}, {
"key": "130",
"points": [{
"x": 5220,
"y": 9180
}, {
"x": 6120,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.77": "Missing info in\nthe documentation?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 1,
"endItemKey": "127",
"endConnectionPointIndex": 0
}, {
"key": "132",
"points": [{
"x": 2160,
"y": 5400
}, {
"x": 2160,
"y": 6120
}
],
"zIndex": 0,
"texts": {
"0.47": "Yes"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 2,
"endItemKey": "131",
"endConnectionPointIndex": 0
}, {
"key": "124",
"points": [{
"x": 2160,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "131",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}, {
"key": "134",
"points": [{
"x": 3420,
"y": 6660
}, {
"x": 5760,
"y": 6660
}
],
"zIndex": 0,
"texts": {
"0.5": "Need developer\nassistance?"
},
"beginItemKey": "131",
"beginConnectionPointIndex": 1,
"endItemKey": "133",
"endConnectionPointIndex": 3
}, {
"key": "135",
"points": [{
"x": 6840,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "133",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}
],
"shapes": [
{
"key": "107",
"type": "terminator",
"text": "A new ticket",
"x": 1440,
"y": 1080,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "108",
"type": "process",
"text": "Analyze\nthe issue",
"x": 900,
"y": 2340,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "118",
"type": "decision",
"text": "Do we have all\ninformation to\nwork with?",
"x": 900,
"y": 3960,
"width": 2520,
"height": 1440,
"zIndex": 0
},
{
"key": "120",
"type": "terminator",
"text": "Answered",
"x": 3780,
"y": 8640,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "121",
"type": "process",
"text": "Request additional\ninformation or clarify\nthe scenario",
"x": 5760,
"y": 4140,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "125",
"type": "process",
"text": "Prepare an example in\nCode Central",
"x": 1620,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "127",
"type": "process",
"text": "Update the\ndocumentation",
"x": 4860,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "131",
"type": "process",
"text": "Process the\nticket",
"x": 900,
"y": 6120,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "133",
"type": "process",
"text": "Work with the\nR&D team",
"x": 5760,
"y": 6120,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "136",
"type": "text",
"locked": true,
"text": "Ticket Processing Flow",
"x": 360,
"y": 360,
"width": 7740,
"height": 360,
"zIndex": 0,
"styleText": {
"font-size": "14pt",
"font-weight": "bold"
}
}
]
}

Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
x
import React, { useEffect, useRef } from 'react';
import {
Diagram,
Command,
ContextMenu,
ContextToolbox,
Group,
HistoryToolbar,
MainToolbar,
PropertiesPanel,
Tab,
Toolbox,
ViewToolbar,
DiagramTypes,
} from 'devextreme-react/diagram';
import { confirm } from 'devextreme/ui/dialog';
import 'whatwg-fetch';
const pageCommands: DiagramTypes.Command[] = ['pageSize', 'pageOrientation', 'pageColor'];
const menuCommands: DiagramTypes.Command[] = ['bringToFront', 'sendToBack', 'lock', 'unlock'];
function onCustomCommand(e: DiagramTypes.CustomCommandEvent) {
if (e.name === 'clear') {
const result = confirm('Are you sure you want to clear the diagram? This action cannot be undone.', 'Warning');
result.then(
(dialogResult) => {
if (dialogResult) {
e.component.import('');
}
},
);
}
}
export default function App() {
const diagramRef = useRef(null);
useEffect(() => {
const diagram = diagramRef.current.instance();
fetch('data/diagram-flow.json')
.then((response) => response.json())
.then((json) => {
diagram.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
}, []);
return (
<Diagram
id="diagram"
ref={diagramRef}
onCustomCommand={onCustomCommand}
>
<ContextMenu
enabled={true}
commands={menuCommands}
/>
<ContextToolbox
enabled={true}
category="flowchart"
shapeIconsPerRow={5}
width={200}
/>
<PropertiesPanel visibility="visible">
<Tab>
<Group title="Page Properties" commands={pageCommands} />
</Tab>
</PropertiesPanel>
<HistoryToolbar visible={false} />
<ViewToolbar visible={true} />
<MainToolbar visible={true}>
<Command name="undo" />
<Command name="redo" />
<Command name="separator" />
<Command name="fontName" />
<Command name="fontSize" />
<Command name="separator" />
<Command name="bold" />
<Command name="italic" />
<Command name="underline" />
<Command name="separator" />
<Command name="fontColor" />
<Command name="lineColor" />
<Command name="fillColor" />
<Command name="separator" />
<Command name={'clear' as any} icon="clearsquare" text="Clear Diagram" />
</MainToolbar>
<Toolbox
visibility="visible"
showSearch={false}
shapeIconsPerRow={4}
width={220}
>
<Group category="general" title="General" />
<Group category="flowchart" title="Flowchart" expanded={true} />
</Toolbox>
</Diagram>
);
}
xxxxxxxxxx
import React, { useEffect, useRef } from 'react';
import {
Diagram,
Command,
ContextMenu,
ContextToolbox,
Group,
HistoryToolbar,
MainToolbar,
PropertiesPanel,
Tab,
Toolbox,
ViewToolbar,
} from 'devextreme-react/diagram';
import { confirm } from 'devextreme/ui/dialog';
import 'whatwg-fetch';
const pageCommands = ['pageSize', 'pageOrientation', 'pageColor'];
const menuCommands = ['bringToFront', 'sendToBack', 'lock', 'unlock'];
function onCustomCommand(e) {
if (e.name === 'clear') {
const result = confirm(
'Are you sure you want to clear the diagram? This action cannot be undone.',
'Warning',
);
result.then((dialogResult) => {
if (dialogResult) {
e.component.import('');
}
});
}
}
export default function App() {
const diagramRef = useRef(null);
useEffect(() => {
const diagram = diagramRef.current.instance();
fetch('data/diagram-flow.json')
.then((response) => response.json())
.then((json) => {
diagram.import(JSON.stringify(json));
})
.catch(() => {
throw new Error('Data Loading Error');
});
}, []);
return (
<Diagram
id="diagram"
ref={diagramRef}
onCustomCommand={onCustomCommand}
>
<ContextMenu
enabled={true}
commands={menuCommands}
/>
<ContextToolbox
enabled={true}
category="flowchart"
shapeIconsPerRow={5}
width={200}
/>
<PropertiesPanel visibility="visible">
<Tab>
<Group
title="Page Properties"
commands={pageCommands}
/>
</Tab>
</PropertiesPanel>
<HistoryToolbar visible={false} />
<ViewToolbar visible={true} />
<MainToolbar visible={true}>
<Command name="undo" />
<Command name="redo" />
<Command name="separator" />
<Command name="fontName" />
<Command name="fontSize" />
<Command name="separator" />
<Command name="bold" />
<Command name="italic" />
<Command name="underline" />
<Command name="separator" />
<Command name="fontColor" />
<Command name="lineColor" />
<Command name="fillColor" />
<Command name="separator" />
<Command
name="clear"
icon="clearsquare"
text="Clear Diagram"
/>
</MainToolbar>
<Toolbox
visibility="visible"
showSearch={false}
shapeIconsPerRow={4}
width={220}
>
<Group
category="general"
title="General"
/>
<Group
category="flowchart"
title="Flowchart"
expanded={true}
/>
</Toolbox>
</Diagram>
);
}
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
xxxxxxxxxx
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
'bundles:': 'bundles/',
'externals:': 'bundles/externals/',
},
defaultExtension: 'js',
map: {
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'whatwg-fetch': 'npm:whatwg-fetch@2.0.4/fetch.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@24.2.5/cjs',
'devextreme-react': 'npm:devextreme-react@24.2.5/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.1/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.15/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.59/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.12',
'inferno': 'npm:inferno@7.4.11/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.12/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
System.config(window.config);
xxxxxxxxxx
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
xxxxxxxxxx
{
"page": {
"width": 8391,
"height": 11907,
"pageWidth": 8391,
"pageHeight": 11906,
"pageLandscape": false,
"gridSize": 180,
"snapToGrid": true
},
"connectors": [{
"key": "116",
"points": [{
"x": 2160,
"y": 1800
}, {
"x": 2160,
"y": 2340
}
],
"zIndex": 0,
"beginItemKey": "107",
"beginConnectionPointIndex": 2,
"endItemKey": "108",
"endConnectionPointIndex": 0
}, {
"key": "117",
"points": [{
"x": 2160,
"y": 3420
}, {
"x": 2160,
"y": 3960
}
],
"zIndex": 0,
"beginItemKey": "108",
"beginConnectionPointIndex": 2,
"endItemKey": "118",
"endConnectionPointIndex": 0
}, {
"key": "122",
"points": [{
"x": 3420,
"y": 4680
}, {
"x": 5760,
"y": 4680
}
],
"zIndex": 0,
"texts": {
"0.45": "No"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 1,
"endItemKey": "121",
"endConnectionPointIndex": 3
}, {
"key": "123",
"points": [{
"x": 6840,
"y": 4140
}, {
"x": 3420,
"y": 2880
}
],
"zIndex": 0,
"beginItemKey": "121",
"beginConnectionPointIndex": 0,
"endItemKey": "108",
"endConnectionPointIndex": 1
}, {
"key": "126",
"points": [{
"x": 3780,
"y": 9180
}, {
"x": 2880,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.78": "A popular scenario?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 3,
"endItemKey": "125",
"endConnectionPointIndex": 0
}, {
"key": "130",
"points": [{
"x": 5220,
"y": 9180
}, {
"x": 6120,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.77": "Missing info in\nthe documentation?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 1,
"endItemKey": "127",
"endConnectionPointIndex": 0
}, {
"key": "132",
"points": [{
"x": 2160,
"y": 5400
}, {
"x": 2160,
"y": 6120
}
],
"zIndex": 0,
"texts": {
"0.47": "Yes"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 2,
"endItemKey": "131",
"endConnectionPointIndex": 0
}, {
"key": "124",
"points": [{
"x": 2160,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "131",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}, {
"key": "134",
"points": [{
"x": 3420,
"y": 6660
}, {
"x": 5760,
"y": 6660
}
],
"zIndex": 0,
"texts": {
"0.5": "Need developer\nassistance?"
},
"beginItemKey": "131",
"beginConnectionPointIndex": 1,
"endItemKey": "133",
"endConnectionPointIndex": 3
}, {
"key": "135",
"points": [{
"x": 6840,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "133",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}
],
"shapes": [
{
"key": "107",
"type": "terminator",
"text": "A new ticket",
"x": 1440,
"y": 1080,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "108",
"type": "process",
"text": "Analyze\nthe issue",
"x": 900,
"y": 2340,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "118",
"type": "decision",
"text": "Do we have all\ninformation to\nwork with?",
"x": 900,
"y": 3960,
"width": 2520,
"height": 1440,
"zIndex": 0
},
{
"key": "120",
"type": "terminator",
"text": "Answered",
"x": 3780,
"y": 8640,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "121",
"type": "process",
"text": "Request additional\ninformation or clarify\nthe scenario",
"x": 5760,
"y": 4140,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "125",
"type": "process",
"text": "Prepare an example in\nCode Central",
"x": 1620,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "127",
"type": "process",
"text": "Update the\ndocumentation",
"x": 4860,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "131",
"type": "process",
"text": "Process the\nticket",
"x": 900,
"y": 6120,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "133",
"type": "process",
"text": "Work with the\nR&D team",
"x": 5760,
"y": 6120,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "136",
"type": "text",
"locked": true,
"text": "Ticket Processing Flow",
"x": 360,
"y": 360,
"width": 7740,
"height": 360,
"zIndex": 0,
"styleText": {
"font-size": "14pt",
"font-weight": "bold"
}
}
]
}
xxxxxxxxxx
<html lang="en">
<head></head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
xxxxxxxxxx
#diagram {
height: 900px;
}

Backend API
<dx-diagram #diagram id="diagram" (onCustomCommand)="onCustomCommand($event)">
<dxo-diagram-context-menu
[enabled]="true"
[commands]="['bringToFront', 'sendToBack', 'lock', 'unlock']"
>
</dxo-diagram-context-menu>
<dxo-diagram-context-toolbox
[enabled]="true"
category="flowchart"
[width]="200"
[shapeIconsPerRow]="5"
>
</dxo-diagram-context-toolbox>
<dxo-diagram-properties-panel visibility="visible">
<dxi-diagram-tab>
<dxi-diagram-group
title="Page Properties"
[commands]="['pageSize', 'pageOrientation', 'pageColor']"
></dxi-diagram-group>
</dxi-diagram-tab>
</dxo-diagram-properties-panel>
<dxo-diagram-history-toolbar [visible]="false"> </dxo-diagram-history-toolbar>
<dxo-diagram-view-toolbar [visible]="true"> </dxo-diagram-view-toolbar>
<dxo-diagram-main-toolbar [visible]="true">
<dxi-diagram-command name="undo"></dxi-diagram-command>
<dxi-diagram-command name="redo"></dxi-diagram-command>
<dxi-diagram-command name="separator"></dxi-diagram-command>
<dxi-diagram-command name="fontName"></dxi-diagram-command>
<dxi-diagram-command name="fontSize"></dxi-diagram-command>
<dxi-diagram-command name="separator"></dxi-diagram-command>
<dxi-diagram-command name="bold"></dxi-diagram-command>
<dxi-diagram-command name="italic"></dxi-diagram-command>
<dxi-diagram-command name="underline"></dxi-diagram-command>
<dxi-diagram-command name="separator"></dxi-diagram-command>
<dxi-diagram-command name="fontColor"></dxi-diagram-command>
<dxi-diagram-command name="lineColor"></dxi-diagram-command>
<dxi-diagram-command name="fillColor"></dxi-diagram-command>
<dxi-diagram-command name="separator"></dxi-diagram-command>
<dxi-diagram-command
name="clear"
icon="clearsquare"
text="Clear Diagram"
></dxi-diagram-command>
</dxo-diagram-main-toolbar>
<dxo-diagram-toolbox
visibility="visible"
[showSearch]="false"
[shapeIconsPerRow]="4"
[width]="220"
>
<dxi-diagram-group category="general" title="General"></dxi-diagram-group>
<dxi-diagram-group
category="flowchart"
title="Flowchart"
[expanded]="true"
></dxi-diagram-group>
</dxo-diagram-toolbox>
</dx-diagram>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import { HttpClient, provideHttpClient, withFetch } from '@angular/common/http';
import { DxDiagramModule, DxDiagramComponent } from 'devextreme-angular';
import { confirm } from 'devextreme/ui/dialog';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
preserveWhitespaces: true,
imports: [
DxDiagramModule,
],
})
export class AppComponent {
@ViewChild(DxDiagramComponent, { static: false }) diagram: DxDiagramComponent;
constructor(http: HttpClient) {
http.get('../../../../data/diagram-flow.json').subscribe({
next: (data) => { this.diagram.instance.import(JSON.stringify(data)); },
error: () => { throw 'Data Loading Error'; },
});
}
onCustomCommand(e) {
if (e.name === 'clear') {
const result = confirm('Are you sure you want to clear the diagram? This action cannot be undone.', 'Warning');
result.then(
(dialogResult) => {
if (dialogResult) {
e.component.import('');
}
},
);
}
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
provideHttpClient(withFetch()),
],
});
::ng-deep #diagram {
height: 900px;
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx-diagram.min.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
{
"page": {
"width": 8400,
"height": 11910,
"pageWidth": 8400,
"pageHeight": 11910,
"pageLandscape": false,
"gridSize": 180,
"snapToGrid": true
},
"connectors": [{
"key": "116",
"points": [{
"x": 2160,
"y": 1800
}, {
"x": 2160,
"y": 2340
}
],
"zIndex": 0,
"beginItemKey": "107",
"beginConnectionPointIndex": 2,
"endItemKey": "108",
"endConnectionPointIndex": 0
}, {
"key": "117",
"points": [{
"x": 2160,
"y": 3420
}, {
"x": 2160,
"y": 3960
}
],
"zIndex": 0,
"beginItemKey": "108",
"beginConnectionPointIndex": 2,
"endItemKey": "118",
"endConnectionPointIndex": 0
}, {
"key": "122",
"points": [{
"x": 3420,
"y": 4680
}, {
"x": 5760,
"y": 4680
}
],
"zIndex": 0,
"texts": {
"0.45": "No"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 1,
"endItemKey": "121",
"endConnectionPointIndex": 3
}, {
"key": "123",
"points": [{
"x": 6840,
"y": 4140
}, {
"x": 3420,
"y": 2880
}
],
"zIndex": 0,
"beginItemKey": "121",
"beginConnectionPointIndex": 0,
"endItemKey": "108",
"endConnectionPointIndex": 1
}, {
"key": "126",
"points": [{
"x": 3780,
"y": 9180
}, {
"x": 2880,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.78": "A popular scenario?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 3,
"endItemKey": "125",
"endConnectionPointIndex": 0
}, {
"key": "130",
"points": [{
"x": 5220,
"y": 9180
}, {
"x": 6120,
"y": 10440
}
],
"zIndex": 0,
"texts": {
"0.77": "Missing info in\nthe documentation?"
},
"beginItemKey": "120",
"beginConnectionPointIndex": 1,
"endItemKey": "127",
"endConnectionPointIndex": 0
}, {
"key": "132",
"points": [{
"x": 2160,
"y": 5400
}, {
"x": 2160,
"y": 6120
}
],
"zIndex": 0,
"texts": {
"0.47": "Yes"
},
"beginItemKey": "118",
"beginConnectionPointIndex": 2,
"endItemKey": "131",
"endConnectionPointIndex": 0
}, {
"key": "124",
"points": [{
"x": 2160,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "131",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}, {
"key": "134",
"points": [{
"x": 3420,
"y": 6660
}, {
"x": 5760,
"y": 6660
}
],
"zIndex": 0,
"texts": {
"0.5": "Need developer\nassistance?"
},
"beginItemKey": "131",
"beginConnectionPointIndex": 1,
"endItemKey": "133",
"endConnectionPointIndex": 3
}, {
"key": "135",
"points": [{
"x": 6840,
"y": 7200
}, {
"x": 4500,
"y": 8820
}
],
"zIndex": 0,
"beginItemKey": "133",
"beginConnectionPointIndex": 2,
"endItemKey": "120",
"endConnectionPointIndex": 0
}
],
"shapes": [
{
"key": "107",
"type": "terminator",
"text": "A new ticket",
"x": 1440,
"y": 1080,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "108",
"type": "process",
"text": "Analyze\nthe issue",
"x": 900,
"y": 2340,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "118",
"type": "decision",
"text": "Do we have all\ninformation to\nwork with?",
"x": 900,
"y": 3960,
"width": 2520,
"height": 1440,
"zIndex": 0
},
{
"key": "120",
"type": "terminator",
"text": "Answered",
"x": 3780,
"y": 8640,
"width": 1440,
"height": 720,
"zIndex": 0
},
{
"key": "121",
"type": "process",
"text": "Request additional\ninformation or clarify\nthe scenario",
"x": 5760,
"y": 4140,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "125",
"type": "process",
"text": "Prepare an example in\nCode Central",
"x": 1620,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "127",
"type": "process",
"text": "Update the\ndocumentation",
"x": 4860,
"y": 10440,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "131",
"type": "process",
"text": "Process the\nticket",
"x": 900,
"y": 6120,
"width": 2520,
"height": 1080,
"zIndex": 0
},
{
"key": "133",
"type": "process",
"text": "Work with the\nR&D team",
"x": 5760,
"y": 6120,
"width": 2160,
"height": 1080,
"zIndex": 0
},
{
"key": "136",
"type": "text",
"locked": true,
"text": "Ticket Processing Flow",
"x": 360,
"y": 360,
"width": 7740,
"height": 360,
"zIndex": 0,
"styleText": {
"font-size": "14pt",
"font-weight": "bold"
}
}
]
}